/*
    DIRSORT_C :  Ordnet Dateien eines Inhaltsverzeichnisses
                 !! Nur fr QL-HD Festplatte, nicht fr Disketten verwendbar !!

    Autor: Dirk Steinkopf
     Februar 1990
    April 1992:  Anpassung an C68 V2.01
*/

#include <stdio.h>
#include <qdos.h>


#define VERSION "Dirsort V2.00  4/92 DStk\n"
#define WHOAMI _prog_name

char _prog_name[] = "dirsort";

#define min(a,b)  ((a) < (b) ? (a) : (b))
#define FNLEN MAXNAMELEN

int compare_dl();



usage()
{
    fprintf(stderr, "Usage: dirsort [-V] dir\n");
    exit(1);
}



main(argc, argv)

int argc;
char *argv[];
{
    int i, err;
    struct DIR_LIST *dlist;
    long chid;
    char startdir[FNLEN];

    if (argc >= 2 && *argv[1] == '-')  {
        i = 1;
        while (i)  {
            switch (argv[1][i++]) {
            case 'V':   fprintf(stderr, VERSION);
                        exit(1);
            case '\0':  if (i == 1)
                            usage();
                        else
                            i = 0;
                        break;
            default:    usage(); break;
            }
        }
        i = 3;
    } else
        i = 2;
    if (argc > i)
        usage();
    if (argc == i) {
        strcpy(startdir, argv[i-1]);
    } else
        getcwd(startdir, FNLEN);  /* current DATA dir */
    if (startdir[strlen(startdir)-1] != '_')
        strcat(startdir, "_");
    strcat(startdir, "*");

    /* Dir lesen */
    dlist = qdir_read(startdir, NULL, QDR_ALL, &err);
    if ((int)dlist < 0) {
        fprintf(stderr, "%s: Cannot read directory %s.\n", WHOAMI, startdir);
        exit(1);
    }

    /* sortieren */
    dlist = qdir_sort(dlist, "x", compare_dl);

    /* zurckschreiben */
    startdir[strlen(startdir)-1] = '\0';
    chid = open_qdir(startdir);
    if (chid < 0) {
        fprintf(stderr, "%s: Cannot write directory %s.\n", WHOAMI, startdir);
        exit(1);
    }
    for ( ; dlist != NULL; dlist = dlist->dl_next) {
        /* puts(dlist->dl_cname); */
        if (DREADSIZE != io_sstrg(chid, -1, &dlist->dl_dir, DREADSIZE)) {
            fprintf(stderr, "%s: Error writing directory %s.\n",
                WHOAMI, startdir);
            io_close(chid);
            exit(1);
        }
    }

    /* Dir auf tatschlich verwendete Lnge krzen */
    io_trunc(chid, -1);
    io_close(chid);
    qdir_delete(dlist);

    exit(0);
}



compare_dl(d1, d2, sort_text)

struct DIR_LIST *d1, *d2;
char *sort_text; /* Not used */
{
    char s1[FNLEN], s2[FNLEN];

    if (d2 == NULL)
        return -1;
    if (d1->dl_dir.d_type == QF_DIR_TYPE && d2->dl_dir.d_type != QF_DIR_TYPE)
        return -1;
    if (d1->dl_dir.d_type != QF_DIR_TYPE && d2->dl_dir.d_type == QF_DIR_TYPE)
        return 1;
    return stricmp(qlstr_to_c(s1, &d1->dl_dir.d_szname),
                   qlstr_to_c(s2, &d2->dl_dir.d_szname));
}
