/*
   QLHD_C :  Funktionen und Tools rund um die QLHD-Harddisc
*/

#include <stdio.h>
#define EXTMODE /* nix */
#include <qlhd.h>

extern char *_sys_var;


short   drive_id    = -1;



char *find_hd(int drive)
{
    char *dr;

    drive_nr = drive;
    if (drive != 1 && drive != 2)
        return "drive number must be 1 or 2";
    if ((int)driver != 0)
        return chk_open_files();
    dr = SYSVAR->ddlst;
    while (dr) {
        if ( *(long *)(dr+MAGIC_POS) == HD_MAGIC ) {
            driver = dr - ACC_POS;
            memcpy((char *)acc_layer, dr, MAGIC_POS);
            return chk_open_files();
        }
        dr = *(char **)dr;
    }
    return "QL-HD not found";
}


char *chk_open_files()

{
    short i;

    driver = (char *)((long)driver & ~(DRIVE1+DRIVE2));
    for (i = 0; i < 16; i++)
        if (SYSVAR->fsdef[i]
          && SYSVAR->fsdef[i]->driver == driver + ACC_POS
          && SYSVAR->fsdef[i]->drive_nr == drive_nr) {
            phys_def = SYSVAR->fsdef[i];
            drive_id = i;
            break;
        }
    driver = (char *)((long)driver + (drive_nr == 1 ? DRIVE1 : DRIVE2));
    if (!(int)phys_def)
        return "No FAT loaded";
    if (phys_def->kennung != KENNW)
        return "Bad harddisc format version";
    if (phys_def->nr_files)
        return "Files open on QLHD";
    return NULL;
}



long log_to_pos(sect)

long sect;   /* logische Sektornummer */
{
    long tr, head;

    tr = sect / (NUM_SECTS * NUM_CYLS);
    sect -= tr * (NUM_SECTS * NUM_CYLS);
    head = sect / NUM_SECTS;
    sect -= head * NUM_SECTS;

    return (long)( (tr << 16) + (head << 8) + sect );
}

