#ifndef EXTMODE
#define EXTMODE extern
#endif



/*
 *    CONST_H :  Includefile fr Harddisk-Devicetreiber
 *
 *    Dies sind die Laufwerksdaten, sie stehen ebenfalls in
 *    "hdsk_asm". Also Vorsicht beim ndern !
 */
/* FAT-Eintrge vor FIRST_USE enthalten die Laufwerksdaten */

#define peek_b(a) (*(unsigned char  *)(a))
#define peek_w(a) (*(unsigned short *)(a))
#define DDATA     ((unsigned char *)(akt_pd->fat))

#define NUM_CYLS     peek_w(DDATA+0)
#define NUM_HEADS    peek_b(DDATA+2)
#define NUM_SECTS    peek_b(DDATA+3)
#define CL_SIZ       peek_b(DDATA+4)     /* Sektoren pro Cluster */
#define CL_SHFT      peek_b(DDATA+5)
#define REDWR        peek_w(DDATA+6)
#define PRECO        peek_w(DDATA+8)
#define DDATA_LEN 10

#define SECLEN    512
#define SECSHFT   9


/*    Cluster- und FAT-Gre.
 *    Die FAT eintlt fr jeden Cluster einen Eintrag:
 *    0     Cluster ist frei
 *    nr    Folgecluster in der entspr. Datei
 *    -1    Cluster ist der letzte in der entspr. Datei
 *    -2    Cluster ist unbrauchbar
 *    -3    Cluster enthlt die Map
 *    Cluster #0 beginnt bei Sector #0, enthlt aber immer die Kopie des
 *    Phys.DefBlocks. Erster brauchbarer Cluster ist FIRST_USE. Dort
 *    beginnt auch das Hauptdirektory
 */
#define FAT_SIZE   (NUM_CYLS*NUM_HEADS*NUM_SECTS/CL_SIZ)
                        /* Anzahl der Eintrge in der FAT */
#define FIRSTUSE ( (2*NUM_PDSECTS-1)/CL_SIZ+1 )
                 /*  ^ Map wird zweimal geschrieben ! */

#define MAX_PD    2     /* Max. Anzahl von Laufwerken */


/*
* Error codes returned by QDOS
*
*/
#ifndef ERR_NC
#define ERR_NC -1   /* operation not complete */
#define ERR_NJ -2   /* not a valid job */
#define ERR_OM -3   /* out of memory */
#define ERR_OR -4   /* our of range */
#define ERR_BO -5   /* buffer overflow */
#define ERR_NO -6   /* channel not open */
#define ERR_NF -7   /* file or device not found */
#define ERR_EX -8   /* file already exists */
#define ERR_IU -9   /* file or device in use */
#define ERR_EF -10   /* end of file */
#define ERR_DF -11   /* drive full */
#define ERR_BN -12   /* bad device name */
#define ERR_TE -13   /* transmission error */
#define ERR_FF -14   /* format failed */
#define ERR_BP -15   /* bad parameter */
#define ERR_FE -16   /* file error */
#define ERR_XP -17   /* error in expression */
#define ERR_OV -18   /* arithmetic overflow */
#define ERR_NI -19   /* not implemented */
#define ERR_RO -20   /* read only */
#define ERR_BL -21   /* bad line in BASIC */
#endif


/*    Operation Codes used for IO-Routine
 */
#define IO_PEND   0  /* Check auf Input */
#define IO_FBYTE  1  /* Holt ein Byte */
#define IO_FLINE  2  /* Holt Zeile bis LF */
#define IO_FSTRG  3  /* Holt String */
#define IO_SBYTE  5  /* Sendet Byte */
#define IO_SSTRG  7  /* Sendet String */
#define FS_CHECK  0x40  /* Check auf anstehende Operationen */
#define FS_FLUSH  0x41  /* Lscht Slaveblocks */
#define FS_POSAB  0x42  /* Abs_ positionieren */
#define FS_POSRE  0x43  /* rel_ pos_ */
#define FS_MDINF  0x45  /* Holt Mediuminfo */
#define FS_HEADS  0x46  /* Setzt Header */
#define FS_HEADR  0x47  /* Liest Header */
#define FS_LOAD   0x48  /* File laden */
#define FS_SAVE   0x49  /* File schreiben */

#define IO_OLD    0
#define IO_SHARE  1
#define IO_NEW    2
#define IO_OVERW  3
#define IO_DIR    4

#define DIR_TYPE  3  /* File-Typ fr Directory */


#define DIR_ANF      '^'
#define DIR_TRENN    '_'
#define DIR_TOP      '!'
#define CREAT_DIR    '&'
#define SET_STDDIR   '$'
#define MAXJOBS      15

#undef DDATA
#define DDATA ((unsigned char *)(phys_def->fat))


/*    PHYSD_H :  Includefile fr Harddisk-Devicetreiber
 *
 *    Dies ist der Aufbau des Physikalischen Definitionsblocks,
 *    der fr jedes Laufwerk einmal existiert.
 *    Die Assemler-Routinen liefern Pointer auf die (am Anfang mit
 *    Nullen gelschte(n)) Struktur(en).
 *    DIE POSITION DER FAT NICHT VERNDERN (S.U.) !!!!!!
 */
typedef struct {
   long len;
      long hdr_a, hdr_b, hdr_c;
   char  *driver;       /* DevTrDefBlock - Vom System besetzt */
   char  drive_nr;      /* Laufwerksnr   - Vom System besetzt */
      char  nil2;
   short len_mednam;    /* Mediumname */
   char  mednam[10];    /*     "      */
   unsigned char nr_files; /* Anzahl der geffneten Files - V.System b. */
   char  stat;          /* OK/BAD */
   char  inited;        /* -> -1, wenn bereits initialisiert */
   char  map_updat;     /* Ges, wenn map. geschr.werden mu */
   short kennung;

   short fat[1];        /* File allocation Table, 1 Eintrag pro Cluster */
                        /* In "io_asm" wird vorrausgesetzt, da sie an  */
                        /* Pos = 40dez im Physd steht */
                        /* Tatschliche Gre wird erst zur Laufzeit bestimmt */
} pdef;

#define KENNW 0x0168
#define NUM_PDSECTS ( ((sizeof(pdef)-2+(FAT_SIZE*2)-1) >> SECSHFT)+1 )




/*
 *    SYSVAR_H :  Includefile fr Harddisk
 *
 *    QDOS-Systemvariablen:
 */

typedef struct {
   unsigned char  blkstat;    /* Drive ID & Status */
   unsigned char  prior;      /* Block Prioritt */
   short sector;     /* Sektornummer auf dem Medium */
   short filnum;     /* Filenummer */
   short blknum;     /* Blocknummer im File */
} slavetab;

typedef struct {
      char unused[0x38];
   char     *i2lst,     /* $38: Interrupt 2 Treiber */
            *plist,     /* $3c: polling list */
            *shlst,     /* $40: scheduler loop list */
            *drlst,     /* $44: device driver list */
            *ddlst,     /* $48: dir-driver */
            *keyq,      /* $4c: akt. Tastatur */
            *trapv;     /* $50: Trapvektor */
   slavetab *btpnt,     /* $54: zuletzt gebrauchter Slaveblock */
            *btbas,     /* $58: Slaveblocktabelle */
            *bttop;     /* $5C: Slaveblocktabellenende */
      char unused2[4];
   char     **jbpnt,    /* $64: akt. Job in Jobtabelle */
            **jbbas,    /* $68: Jobttabelle */
            **jbtop;    /* $6C: Jobtab.ende */
      char unused3[0x90];
   pdef     *fsdef[16];  /* $100: Zeiger auf PDBs */
} sysv;


/*    Aufbau der Slaveblocktabelle:
 *       (slavetab, s.o.)
 */

/*    blkstat enthlt:
 *    bit 4-7:  drive ID
 *        0-3:  status:
 *              bit 0:  Block ist ein Fileblock
 *                  1:  Block hat den korrekten Fileinhalt
 *                  2:  Block mu geschrieben werden
 *                  3:  Block mu gelesen/verifiziert werden
 */
#define SL_UNAV   0
#define SL_EMPTY  1
#define SL_RREQ   9
#define SL_TRUE   3
#define SL_AVER   11
#define SL_UPDT   7

/* Masken zur Ausblendung von Bits:
 */
#define SL_ACTN   12
#define SL_INUSE  14



/*
 *     FHEADER_H :  Incudefile fr Harddisk
 * 
 * the following structure defines the standard QDOS file header
 * changed slightly for HDK
 */

#define FNLEN 36

typedef struct {
   long           length;        /* file length      */
   char           access;        /* file access type   */
   char           type;          /* file type      */
   long           info1,info2;   /* type dependent info   */
   short          name_sz;       /* size of name      */
   char           name[FNLEN];   /* name area      */
   long           dat_change;    /* Date of last file change */
   unsigned short version;       /* Number of changes since creation */
   short          first_cluster; /* Erster Cluster des Files */
   long           dat_backup;    /* Date of last backup */
} fheader;

#define HSIZ (sizeof(fheader))




/*
 *    CHANDEF_H :  Includefile fr Harddisk
 *
 *    Filesystem-Kanaldefinitionsblock:
 */

typedef struct i_cdef {
   long  chlen;      /* 0 Lnge des Definitionsblocks */
   char  *driver;    /* 4 Adresse des Devicetreibers */
   long  owner;      /* 8 Besitzerjob-Id */
   char  *rldaddr;   /* 12 Adresse in der Kanaltabelle */
   short chtag;      /* 16 Kanal-Tag */
   char  status;     /* 18 Kanalstatus (wartend...) */
   char  staction;   /* 19 gespeicherte Operation fr wartenden Kanal */
   long  jobwt;      /* 20 ID of waiting Job */

   struct i_cdef *nextch;    /* 24 Zeiger auf nchsten FS-Kanal */
   char  accessm;    /* 28 Zugriffsmodus */
   char  driveid;    /* 29 Laufwerks ID */
   short filenr;     /* 30 Filenummer = 1.Cluster */
   short nxtblock, nxtbyte;  /* 32 Block- u.Bytenummer von nchstem Byte */
   short eofblock, eofbyte;  /* 36 Block- u.Bytenummer des EOF */
   slavetab *curslv; /* 40 Zeiger auf akt. Eintrag in Slaveblocktabelle */
   char  updat;      /* 44 gesetzt, wenn File gendert wurde */
   char  wr_header;  /* 45 gesetzt, wenn FHeader geschr.w.mu */
   short dirnr;      /* 46 Filenummer des Direktories */
   short pos_in_dir; /* 48 Eintragsnummer im Direktory */
   short len_fnam;   /* 50 Filename */
   char  fnam[FNLEN];
   fheader spare;    /* 88 Scratch-Fileheader */
   char  noread;     /* 152 ges., wenn File als leer erscheinen soll */
} cdef;



/*
 *    DEVDEF_H :  Headerfile fr Harddisk
 *
 *
 *    Dies ist def Devicetreiber-Definitionsblock,
 *    dessen Beginn auch in "hdsk_asm" steht.
 *    (Er darf u.a. deshalb nicht verndert werden.)
 *    In ihm stehen auch alle C-Variablen. Sie werden ber A5 adressiert.
 *    Da der DevTrDefBlock nur einmal existiert, mssen die Interupts
 *    whrend der C-Ausfhrung nicht ausmaskiert werden, um eine Konfusion
 *    der Variablen durch mehrere hdk-Operationen ausfhrende Jobs zu
 *    verhindern, da der Scheduler den Supervisor-Modus nicht unterbricht.
 *    (s. "hdsk_asm")
 *
 *    Vor dem Includen dieses Files mu EXMODE definiert sein:
 *    <nichts> :  Variablen (s.u.) werden definiert
 *    extern   :  Variablen (s.u.) werden deklariert
 */

#define HD_MAGIC 817160257
EXTMODE char  *phys_layer[6];   /* Definitionen des phys.Layers - nicht verwendet */
EXTMODE char  *acc_layer[8];    /* Definition d. Accesslayers */
EXTMODE long  len_pd;
EXTMODE short len_devnam;
EXTMODE char  devnam[4];
EXTMODE long  hd_magic;         /* Zur Erkennung des HD-Treibers */
EXTMODE char  *ad_read;         /* Einsprung zum Sektor Lesen */
EXTMODE char  *ad_write;        /* Einsprung zum Sektor Schreiben */
EXTMODE char  *ad_init;         /* Einsprung zum Controller initen */
EXTMODE char  *ad_form;         /* Einsprung zum Formatieren der Platte */
EXTMODE char  *ad_fill;         /* Einsprung zum Fllen des Sektorpuffers */

EXTMODE long  varscratch[4];    /* von Assembler benutzt */

EXTMODE sysv  *sv;              /* Zeiger auf Systemvariablen */
EXTMODE pdef  *pd[MAX_PD];      /* Phydefs */
EXTMODE long  pdsizes[MAX_PD];  /* Lnge der PDBlocks, 0 = unbekannt */
EXTMODE cdef  *akt_ch;          /* aktueller Kanal */
EXTMODE pdef  *akt_pd;          /* aktueller PDB */




EXTMODE char *driver;     /* Adresse des QLHD-Tribers */
EXTMODE short drive_nr;   /* Laufwerksnummer: 1 o. 2 */
EXTMODE pdef *phys_def;   /* Adresse des physikalischen Defblocks des Laufwerks */
extern char *_sys_var;
#define SYSVAR ((sysv *)_sys_var)

#define MAGIC_POS ((char *)&hd_magic - (char *)acc_layer)
       /* rel. Pos. der Magic-Nr im Devtreiberdefblock */
#define ACC_POS ((char *)acc_layer - (char *)phys_layer)
typedef int (*FP)();

#define call(ad) (*(*(FP *)(ad)))
#define MEMPOS(which) (driver + ((char *)&which-(char *)phys_layer))
#define rd_hd_ms(pos,n,buf,d)  call(MEMPOS(ad_read)) ((pos),(n),(buf),(d))
#define wr_hd_ms(pos,n,buf,d)  call(MEMPOS(ad_write))((pos),(n),(buf),(d))
#define fill_hd(pat,d)         call(MEMPOS(ad_fill)) (pat,(d))
#define fmt_hd(inter,d)        call(MEMPOS(ad_form)) (inter,(d))
#define init_hd(hd_data,d)     call(MEMPOS(ad_init)) (hd_data,(d))

#define DRIVE1 (1 << 29)
#define DRIVE2 (1 << 30)

char *find_hd(int drive);
char *chk_open_files();
long log_to_pos(long sect);
