*
*  ASSIGN_ASM     Erweiterung, die die Verwendeung von
*                 Pseudo-Devices erlaubt.
*
*  Nachdem z.B. "hd__" als "hdk1_!c_hd_new_" definiert wurde, kann man
*  "hd__open_c" als Abkrzung fr die Datei "hdk1_c_hd_new_open_c" verwenden.
*
*  Definition von Basic aus: ASSIGN "hd__", "hdk1_!c_hd_new_"
*  Lschen:                  UNASSIGN "hd__"
*
*  Vorsicht:
*  Dieses System der Assigns funktioniert von allen Jobs aus, bei allen
*  OPEN-Operationen, aber NICHT beim Lschen der Dateien! Leider, leider...
*  Also: DELETE hd__xyz  hat keine Wirkung!
*
*
*  (C) Juni 1991
*  Autor: Dirk Steinkopf
*
*

         include  hdk1_!ass_inc_qdos1_in
         include  hdk1_!ass_inc_macro_lib

max_fn   equ      36
magic_nr equ      $65b104f6



         offset   0
         ds.l     4                 Definitionblock
fn_buf   ds.b     max_fn+20         Buffer fr Filename
fn_end
magic    ds.l     1                 Idetifikationswort
llist    ds.l     1                 verkettete Liste auf alle Assigns
def_len  ds.w     0



         section  asm

init     move.l   #def_len,d1
         moveq    #0,d2
         qdosmt$  mt.alchp                   Speicher fr Dev-Treiber-Def
         tst.l    d0
         bne.s    ret
         lea      pd_open,a2
         move.l   a2,8(a0)                   Def-Block initen
         clr.l    llist(a0)
         move.l   #magic_nr,magic(a0)
         qdosmt$  mt.liod                    ... und anmelden

         lea      proctab,a1
         qdosvc$  bp.init,a2                 BASIC-Prozeduren initen

         lea      text,a1                    Message ausgeben
         sub.l    a0,a0
         qdosvc$  ut.mtext,a2
ret      rts

text     string$  {'Pseudo-Devices V1.01 - 6/91 DStk',10}

proctab  dc.w     2                          Prozedurenanzahl
         dc.w     assign-*
         dc.b     6,'ASSIGN'
         dc.w     unassign-*
         dc.b     8,'UNASSIGN'
         dc.w     0,0,0


*******************************
     assign:
*******************************
         ; Hole Parameterstrings
         qdosvc$  ca.gtstr,a2                Hole Strings
         bne      ret
         cmp.w    #2,d3                      genau 2 Strings?
         bne      ret_bp

         ; Check d. 1. Strings (= Assign-Name) auf Gltigkeit
         move.l   a1,d0
         move.w   0(a6,d0.l),d1              Lnge d. 1 Strings
         subq.w   #1,d1
         bmi      ret_bp                     Null-String nicht erlaubt
chkstr   cmp.b    #'_',2(a6,d0.l)            '_' (nur) am Ende erlaubt
         bne.s    n_underl
         cmp.b    #'_',3(a6,d0.l)            zwei '_'?
         bne      ret_bp
         cmp.b    #1,d1                      am Ende?
         bne      ret_bp
         addq.l   #2,d0                      2(a6,d0) > hinter letztes Zeichen
         moveq    #0,d4                      merke: kein '_' anhngen
         bra.s    str_ok
n_underl cmp.b    #'0',2(a6,d0.l)            Ziffer?
         blt.s    no_ziff
         cmp.b    #'9',2(a6,d0.l)
         bgt.s    no_ziff
         moveq    #1,d4                      merke: ein '_' anhngen
         tst.w    d1                         ja -> nur an letzter Stelle
         beq.s    ziff_ok
         cmp.b    #'_',2+1(a6,d0.l)          oder wie "flp1_"
         bne      ret_bp
         cmp.w    #1,d1
         bne      ret_bp
         moveq    #0,d4                      kein weiteres '_' ntig
         addq.l   #2,d0                      2(a6,d0) > hinter letztes Zeichen
         bra.s    str_ok
ziff_ok  addq.l   #1,d0
         bra.s    str_ok

no_ziff  addq.l   #1,d0                      nchstes Zeichen
         dbf      d1,chkstr
         moveq    #2,d4                      merke: zwei '_' anhngen

         ; Speicher fr die Strings reservieren
str_ok   clr.l    d1
         move.w   0(a6,a1.l),d1              1. Lnge
         move.l   d1,d2
         add.w    d4,d1                      evtl. '_' anhngen
         and.w    #1,d2
         add.l    d2,d0
         addq.l   #2,d0                      d0 = nchster String
         add.l    d2,d1
         move.w   0(a6,d0.l),d2              2. Lnge
         beq.s    ret_bp                     Nullstring nicht erlaubt
         add.w    d2,d1                      + 2. Lnge
         addq.l   #8,d1                      fr verkettete Liste +Stringlngen
         moveq    #0,d2
         movem.l  a1/d0,-(a7)
         qdosmt$  mt.alchp                   Speicher holen
         movem.l  (a7)+,a1/d2
         tst.l    d0
         bne      ret
         ; a0 = Speicher
         ; (a6,a1.l) = 1. String
         ; (a6,d2.l) = 2. String

         ; Strings abspeichern und in Liste eintragen
         lea      4(a0),a2                   hier: Platz fr 1. String
         move.w   0(a6,a1.l),d0              Anzahl zu kopierender Zeichen
         add.w    d4,d0                      plus zus. '_'
         move.w   d0,(a2)+
         subq.w   #1,d0
cp_1     cmp.w    d4,d0                      normales Zeichen oder zus. '_'?
         bge.s    cp_norm
         move.b   #'_',(a2)+                 '_' anhngen
         bra.s    cp_nxt
cp_norm  move.b   2(a6,a1.l),(a2)+           kopiere 1 Zeichen
         addq.l   #1,a1
cp_nxt   dbf      d0,cp_1                    nchstes Zeichen
         move.w   4(a0),d0                   1. Lnge
         and.w    #1,d0
         add.w    d0,a2                      gerade Adr = Platz f. 2.String
         move.w   0(a6,d2.l),d0              2. Lnge
         move.w   d0,(a2)+
         subq.w   #1,d0
cp_2     move.b   2(a6,d2.l),(a2)+           kopiere 1 Zeichen
         addq.l   #1,d2
         dbf      d0,cp_2                    nchstes Zeichen
         bsr.s    get_def                    a2 = Defblock
         lea      llist(a2),a1               Zeiger auf Liste
         qdosvc$  ut.link,a2                 Element eintragen

         clr.l    d0
         rts


ret_bp   moveq    #err.bp,d0
         rts
ret_bo   moveq    #err.bo,d0
         rts
ret_ni   moveq    #err.ni,d0
         rts


*********************************
 subroutine$ get_def, d0-d2/a0               a2 wird zurckgegeben
*********************************
         qdosmt$  mt.inf                     a0 > Sysvar
         move.l   sv_drlst(a0),a2            Liste der Devicetreiber
         move.l   #magic_nr,d1
srch_mag cmp.l    magic(a2),d1               Suche Magic-Number
         beq.s    mag_fnd
         move.l   (a2),a2                    verfolge Liste
         move.l   a2,d0
         bne      srch_mag
         bra.s    ret_ni                     kann nicht vorkommen
mag_fnd

  end$


*********************************
     unassign:
*********************************
         ; Hole Parameter
         qdosvc$  ca.gtstr,a2                Hole String
         bne      ret
         cmp.w    #1,d3                      genau einer?
         bne      ret_bp

         ; Suche Assign in der Liste
         lea      2(a1),a0                   (a6,a0) > 1. Zeichen
         move.w   0(a6,a1.l),d0              Assign-Lnge
         bsr      get_def                    a2 = Defblock
         move.l   a2,a3
         bsr.s    search_assign              d0 > Assign-Block
         tst.l    d0
         beq      ret_nf                     Assign nicht gefunden

         ; aus der Liste lschen und Speicher freigeben
         move.l   d0,a0                      Assign-Block
         lea      llist(a3),a1               Listenstart
         qdosvc$  ut.unlnk,a2                aus der Liste herausnehmen
         qdosmt$  mt.rechp                   Speicher freigeben

         clr.l    d0
         rts

*********************************
mlower   macro    reg
*********************************
         cmp.b    #'A',[reg]
         blt.s    n_up[.l]
         cmp.b    #'Z',[reg]
         bgt.s    n_up[.l]
         add.b    #'a'-'A',[reg]
n_up[.l]
         endm


*********************************
 subroutine$ search_assign, a0-a2/d1-d2         d0 wird zurckgegeben
*********************************
         ; (a6,A0) > 1.Zeichen des Namens
         ; A3 > Defblock
         ; D0 = Assign-Lnge

         ; suche Assign in der Liste
         move.l   a0,a1
         move.l   llist(a3),a2               Listenstart
srch_ass move.l   a2,d1
         beq.s    end_list                   Ende der Liste?
         cmp.w    4(a2),d0                   gesuchte Assign-Lnge?
         bne.s    nxt_ass
         subq.w   #1,d0
         add.w    d0,a0
cmp_ass  move.b   4+2(a2,d0.w),d1            vergleiche Assign mit Namen
         mlower   d1                         Gro-/Kleinschreibung unwichtig
         move.b   0(a6,a0.l),d2
         mlower   d2
         cmp.b    d2,d1
         bne.s    nxt_ass1                   verschieden!
         subq.l   #1,a0
         dbf      d0,cmp_ass
         bra.s    ass_fnd
nxt_ass1 move.l   a1,a0                      restauriere Namensanfang
         move.w   4(a2),d0                   restauriere Assign-Lnge
nxt_ass  move.l   (a2),a2                    verfolge Liste
         bra.s    srch_ass

end_list clr.l    d0                         nicht gefunden!
         bra.s    srch_ret

ass_fnd  move.l   a2,d0                      Adresse des Assign-Blocks
srch_ret

 end$



*********************************
     pd_open:
*********************************
         add.w    #$18,a3                    a3 > Defblock, a0 > Name

         ; untersuche zu ffnenden Namen:
         ; = bestimme Lnge eines evtl. vorhandenen Assigns
         move.w   (a0)+,d0                   Lnge
         move.l   a0,a1
         beq.s    ret_nf
         subq.w   #1,d0
chk_nam  cmp.b    #'_',(a1)                  '__' begrenzt Assign
         bne.s    no_und                     (gehrt dazu)
         cmp.b    #'_',1(a1)
         bne.s    noassign
         addq.l   #2,a1                      a1 zeigt hinter letztes Zeichen
         bra.s    end_ass
no_und   cmp.b    #'0',(a1)                  Ziffer begrenzt auch
         blt.s    nodigit                    (gehrt noch dazu)
         cmp.b    #'9',(a1)+
         bgt.s    nodigit1
         cmp.b    #'_',(a1)                  folgt ein '_'?
         bne.s    noassign                   nein
         addq.l   #1,a1                      ja => es gehrt dazu
         bra.s    end_ass
nodigit  addq.l   #1,a1
nodigit1 dbf      d0,chk_nam                 nchstes Zeichen
end_ass  move.l   a1,d0                      zeigt hinter letztes Assign-Zchn
         sub.l    a0,d0                      Assign-Lnge
         sub.l    a6,a0                      rel. zu a6 machen
         ; (a6,A0) > 1.Zeichen des Namens
         ; A1 > hinter letztes Zeichen des Assigns
         ; A3 > Defblock
         ; D0 = Assign-Lnge

         bsr      search_assign
         add.l    a6,a0                      A0 wieder absolut
         subq.l   #2,a0                      Alter Wert
         tst.l    d0
         bne.s    found
ret_nf   moveq    #err.nf,d0
         rts

noassign subq.l   #2,a0                      alter a0-Wert
         bra      ret_nf                     => es ist nicht geschehen

         ; A0 > Name
         ; A1 > hinter letztes Zeichen des Assigns
         ; d0 > gefundener Assign-Block
         ; A3 > Defblock
         ; setzte neuen Namen zusammen:
found    move.l   d0,a2
         addq.l   #4,a2
         move.w   (a2)+,d0                   Assign-Lnge
         move.w   d0,d1
         add.w    d0,a2
         and.w    #1,d0                      nchste gerade Adresse
         add.w    d0,a2                      = Ersetzungsstring

         lea      fn_buf+2(a3),a4            hier entsteht neuer Name
         move.w   (a2)+,d0                   Ersetzungslnge
         lea      fn_end(a3),a5              Max. bis hierher Platz
         sub.w    d0,a5
         cmp.l    a4,a5                      genug Platz?
         blt      ret_bo
         subq.w   #1,d0
cp_ers   move.b   (a2)+,(a4)+                kopiere Ersetzungsstring
         dbf      d0,cp_ers

         move.w   (a0),d0                    alte Lnge des Namens
         sub.w    d1,d0                      Lnge ohne Assign
         beq.s    cp_ok
         lea      fn_end(a3),a5              Max. bis hierher Platz
         sub.w    d0,a5
         cmp.l    a4,a5                      genug Platz?
         blt      ret_bo
         subq.w   #1,d0
cp_rest  move.b   (a1)+,(a4)+                kopiere Rest des Namens
         dbf      d0,cp_rest

cp_ok    move.l   a4,d0
         lea      fn_buf+2(a3),a0            neuer Name = Returnwert
         sub.l    a0,d0                      neue Lnge
         move.w   d0,-(a0)
         bra.s    ret_nf



         end

